package com.company.test15.listener;

import com.company.test15.entity.Histor;
import com.company.test15.entity.Payment;
import io.jmix.core.DataManager;
import io.jmix.core.event.EntityChangedEvent;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.event.EventListener;
import org.springframework.stereotype.Component;

import java.util.UUID;

@Component
public class PaymentEventListener {
    @Autowired
    DataManager dataManager;

    @EventListener
    public void onPaymentChangedBeforeCommit(final EntityChangedEvent<Payment> event) {
        Histor histor = dataManager.create(Histor.class);
        histor.setObjId((UUID) event.getEntityId().getValue());
        histor.setEvent(event.toString());
        dataManager.save(histor);
    }
}